package cn.net.cpzslibs.prot;

import com.google.gson.Gson;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;

import cn.net.cpzslibs.prot.bean.req.Prot10068ReqBean;
import cn.net.cpzslibs.prot.bean.res.Prot10068ResBean;
import cn.net.cpzslibs.prot.utils.StrUtils;


public class Prot10068FireExtinguisher extends ProtBase {
	/**
	 * 是否成功
	 */
	private short iResult;
	
	private final short iTaskCode10068 = 10068;
	private Gson gson;
	private Prot10068ResBean resBean;
	
	public Prot10068FireExtinguisher() {
//		this.sInspectorId = sInspectorId;
		gson = new Gson();
	}
	
	public Prot10068ResBean getFireRes(){
		return this.resBean;
	}
	
	public void dealFireExtinguisher(SocketCreate create, Prot10068ReqBean reqBean) throws IOException {
		recProt(create.getSocket(), create.getDos(), create.getDis(), reqBean);
	}
	
	private void recProt(Socket socket, DataOutputStream dos,
			DataInputStream dis, Prot10068ReqBean reqBean)
			throws IOException {
		if (socket.isConnected()) {
			if (!socket.isOutputShutdown()) {
				//发送登录信息
				debugLog(iTaskCode10068, "开始请求灭火器信息");
				sendProt(dos, reqBean);
			}
		}
		if (socket.isConnected()) {
			if (!socket.isInputShutdown()) {
				recLoginDis(dis);
			}
		}
	}
	
	/**
	 * 读取JSon数据
	 * @param dis
	 * @throws IOException
	 */
	private void recLoginDis(DataInputStream dis) throws IOException {
		debugLog(iTaskCode10068, "获取接收的数据");
		recHeader(dis);
		int jsonLength = getiRecBodySize() - 2;
		String jsonData = getUTF8(dis, jsonLength);
		debugLog(iTaskCode10068, jsonData);
//		{"check_date":"2016-10-04","check_user":"李扬","check_user_tel":"15726673655","company_name":"哈尔滨消防公司测试","next_check_date":"2017-10-04","num":"50000","product_name":"2017-12-25","surplus":"2"}
//		JSONObject object1 = new JSONObject(content);
		if (!StrUtils.isEmpty(jsonData)) {
			resBean = gson.fromJson(jsonData, Prot10068ResBean.class);
		}
		recCheckCode(dis);
	}
	
	
	/**
	 * 发送JSon数据到服务器
	 * @param dos
	 * @param iUserType
	 * @param loginBean
	 * @throws IOException
	 */
	private void sendProt(DataOutputStream dos, Prot10068ReqBean reqBean) throws IOException {
		String bodyContent = gson.toJson(reqBean).toString();
		short bodySize = countBodySize(bodyContent);
		sendHeader(dos, iTaskCode10068, bodySize);// 84
		dos.write(bodyContent.getBytes("UTF-8"));
//		sendCheckCode(dos);
		sendCheckCoded(dos,bodyContent.getBytes("UTF-8"));
	}
	

}
